/*
 * Copyright (C) 2013 Darth Affe <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.controls;

import com.jme3.bounding.BoundingVolume;
import com.jme3.collision.CollisionResults;
import com.jme3.scene.Node;
import com.jme3.scene.Spatial;
import com.jme3.scene.control.Control;
import org.wyrez.shootingstars.helper.UserDataKeys;

/**
 *
 * @author Snowsun
 */
public class WeaponProjectileCollisionControl extends BaseControl {

    private Node starNode;
    private BoundingVolume boundingVolume;
    private CollisionResults results;

    public WeaponProjectileCollisionControl(Node starNode) {
        this.starNode = starNode;
        this.results = new CollisionResults();
    }

    @Override
    public void setSpatial(Spatial spatial) {
        super.setSpatial(spatial);
        boundingVolume = spatial.getWorldBound();
    }

    @Override
    protected void controlUpdate(float tpf) {
        for (Spatial s : starNode.getChildren()) {
            results.clear();
            s.collideWith(boundingVolume, results);
            if (results.size() > 0) {
                s.setUserData(UserDataKeys.HITTED, true);
            }
        }
    }

    public Control cloneForSpatial(Spatial spatial) {
        WeaponProjectileCollisionControl control = new WeaponProjectileCollisionControl(starNode);
        spatial.addControl(control);
        return control;
    }
}
